#
# DigitalWatchGUI.py
#
# class DigitalWatchGUI provides a simple Tkinter GUI for a Digital Watch
#

# to add: battery dies ...

from Tkinter import *

from DrawLineStatechart import *


class DrawLineGUI:
  
  def __init__(self, parent):
    self.controller = DrawLineGUI_Controller()    
    self.staticGUI  = DrawLineGUI_Static(parent, self.controller)
    self.dynamicGUI = DrawLineGUI_Dynamic(self.controller)
    

           
class DrawLineGUI_Controller:

  def __init__(self):
    self.statechart = None
    self.GUI  = None
        
  def bindDynamic(self, statechart):
    self.statechart = statechart
  
  def bindStatic(self, GUI):
    self.GUI = GUI
              
  #Interface for the GUI                                 
  def window_close(self):
    import sys
    sys.exit(0)
    self.statechart.event('GUI Quit')

  def button1_selected(self):
    self.statechart.event('button1_selected')

  def button2_selected(self):
    self.statechart.event('button2_selected')

  def button3_selected(self):
    self.statechart.event('button3_selected')

  def button1pressed(self):
    self.statechart.event('button1pressed')

  def button1motion(self):
    self.statechart.event('button1motion')

  def button1released(self):
    self.statechart.event('button1released')

  def mouse_coord_inFrame1(self):
    self.mouse_coord_inFrame1.event('mouse_coord_inFrame1')

  def mouse_coord_sup(self):
    self.mouse_coord_inFrame1.event('mouse_coord_sup')

  def add_pt1(self,event):
    self.GUI.add_pt1(event)

  def add_pt2(self,event):
    self.GUI.add_pt2(event)

  def draw_line(self):
    self.GUI.draw_line()

  def select_objet(self):
    self.GUI.select_objet()
    
  def delete_objet(self):
    self.GUI.delete_objet()
    
  def  drawMovingObjet(self):
    self.GUI.drawMovingObjet()

  def stop_move():
    self.GUI.stop_move()


class DrawLineGUI_Dynamic:
  
  def __init__(self, controller):
    self.controller = controller
    self.statechart = DrawLineStatechart()
    self.statechart.initModel()     
    self.controller.bindDynamic(self.statechart)
    self.statechart.event("start", self.controller)
    
      

#======================================================================#
# GUI Static class

class DrawLineGUI_Static(Frame):

  def __init__(self, parent, controller):
    Frame.__init__(self, parent)

    self.parent = parent
    self.controller = controller
    self.controller.bindStatic(self)

    self.tab_pts = []
    self.second = 0
    self.modeString = "Draw"
    self.moveMode = "Idle"
 
    self.createWidgets()
    
    #self.b_playpause.focus_force()
    parent.protocol("WM_DELETE_WINDOW", self.controller.window_close)
    
    self.drawTime()
    self.drawDate()
          
  def createWidgets(self):

    self.pack(fill=BOTH, expand=1)
    self.drawing=Canvas(self, bg = "white",width = 500, height = 500)
    self.line = self.drawing.create_line((0,400,500,400), fill = "grey", width = 4)
    self.rectangle = self.drawing.create_rectangle(0,400,500,500,fill = "grey")
    self.label = self.drawing.create_text(70,440,fill = "blue", text = "")
    self.insert_valid = self.drawing.create_text(70,440,fill = "blue", text = "@")
    self.drawing.create_text(95,440,fill = "black", text = "Insert")
    self.move_valid = self.drawing.create_text(230,440,fill = "black", text = "o")
    self.drawing.create_text(257,440,fill = "black", text = "Move")
    self.delete_valid = self.drawing.create_text(390,440,fill = "black", text = "o")
    self.drawing.create_text(420,440,fill = "black", text = "Delete")
    self.drawing.focus_set()
    self.drawing.pack()


    self.rect2 = self.drawing.create_rectangle(220,470,270,492,fill = "white")
    self.label = self.drawing.create_text(245,480,fill = "red", text = self.modeString)
                                                                                                                                  
    self.drawing.bind("<ButtonPress-1>", self.onDrawingMouse1Press)
    self.drawing.bind("<ButtonRelease-1>", self.onDrawingMouse1Release)
    self.drawing.bind("<B1-Motion>", self.onDrawingMouse1Motion)                                                             

  def defineMode(self,event):
    if (event.y > 420 and event.y < 470):
      if (event.x > 65 and event.x < 130 ):
        print "Changement pour insert"
        self.drawing.itemconfigure(self.insert_valid , fill="blue" , text = "@")
        self.drawing.itemconfigure(self.move_valid , fill="black" , text = "o")
        self.drawing.itemconfigure(self.delete_valid , fill="black" , text = "o")
        self.button1_selected()
      elif (event.x > 225 and event.x < 290 ):
        print "Changement pour Move"
        self.drawing.itemconfigure(self.insert_valid , fill="black" , text = "o")
        self.drawing.itemconfigure(self.move_valid , fill="blue" , text = "@")
        self.drawing.itemconfigure(self.delete_valid , fill="black" , text = "o")
        self.button2_selected()
      elif (event.x > 385 and event.x < 450 ):
        print "Changement pour Delete"
        self.drawing.itemconfigure(self.insert_valid ,fill="black" , text = "o")
        self.drawing.itemconfigure(self.move_valid , fill="black" , text = "o")
        self.drawing.itemconfigure(self.delete_valid , fill="blue" , text = "@")
        self.button3_selected()


  def onDrawingMouse1Release(self, event):
    self.button1released()

  def onDrawingMouse1Motion(self, event):
    self.button1motion()
  
  def onDrawingMouse1Press(self, event):
    if (event.y>400):
      self.mouse_coord_sup()
      self.defineMode(event)
      self.drawing.itemconfigure(self.label, text = self.modeString)
    else:
      self.button1pressed()

  def add_pt1(self,event):
    self.tab_pts.append(event.x)
    self.tab_pts.append(event.y)

  def add_pt2(self,event):
    self.tab_pts.append(event.x)
    self.tab_pts.append(event.y)

  def draw_line(self):
    self.drawing.create_line((self.tab_pts[0], self.tab_pts[1], self.tab_pts[2], 
        self.tab_pts[3]), fill="red",width = 2)
    self.tab_pts.pop(0)
    self.tab_pts.pop(0)
    self.tab_pts.pop(0)
    self.tab_pts.pop(0)

  def select_objet(self):
    self.objet_selected = self.drawing.find_closest(event.x, event.y)
    
  def delete_objet(self):
    if (self.objet_selected[0] == self.line or self.movingObject[0] == self.rectangle):
      print "Cet objet est impossible a supprimer"
    else:
      self.drawing.delete(self.objet_selected)
    
  def  drawMovingObjet(self):
    self.oldCoords=self.drawing.coords(self.movingObject)
    self.drawing.move(self.movingObject, event.x-self.oldCoords[0],event.y-self.oldCoords[1])

  def stop_move():
    if (self.objet_selected[0] == self.line ):
      self.drawing.delete(self.line)
      self.line = self.drawing.create_line((0,400,500,400), fill = "grey", width = 4)
    elif (self.movingObject[0] == self.rectangle): 
      self.drawing.delete(self.rectangle)
      self.rectangle = self.drawing.create_rectangle(0,400,500,500,fill = "grey")
    #elif self.modeString == "Draw":
    #  if self.second == 0:
    #    self.tab_pts.append(event.x)
    #    self.tab_pts.append(event.y)
    #    self.second = 1
    #  else:
    #    self.tab_pts.append(event.x)
    #    self.tab_pts.append(event.y)
    #    self.drawing.create_line((self.tab_pts[0], self.tab_pts[1], self.tab_pts[2], 
    #    self.tab_pts[3]), fill="red",width = 2)
    #    self.tab_pts.pop(0)
    #    self.tab_pts.pop(0)
    #    self.tab_pts.pop(0)
    #    self.tab_pts.pop(0)
    #    self.second = 0
    #elif self.modeString == "Delete":
    #  self.objet_selected = self.drawing.find_closest(event.x, event.y)
    #  print self.objet_selected[0]
    #  print self.line
    #  if (self.objet_selected[0] == self.line or self.movingObject[0] == self.rectangle):
    #    print "Cet objet est impossible a supprimer"
    #  else:
    #    self.drawing.delete(self.objet_selected)
    #elif self.modeString == "Move":
    #  self.moveMode = "Moving" 
    #  self.movingObject = self.drawing.find_closest(event.x, event.y)
    #  if (self.movingObject[0] == self.line or self.movingObject[0] == self.rectangle):
    #    print "Cet objet est impossible a deplacer"
    #    self.moveMode = "idle"
    #    self.movingObject = None
    #else:
    #  print "Unknown mode"


                                                                            
